/// @cond EO_CXX_EO_IMPL

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool elm_interface_atspi_editable_text::insert(::efl::eina::string_view string_, int position_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_insert(::efl::eolian::to_c(string_), position_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool elm_interface_atspi_editable_text::copy(int start_, int end_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_copy(start_, end_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool elm_interface_atspi_editable_text::cut(int start_, int end_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_cut(start_, end_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool elm_interface_atspi_editable_text::delete_(int start_, int end_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_delete(start_, end_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool elm_interface_atspi_editable_text::paste(int position_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_paste(position_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool elm_interface_atspi_editable_text::content_set(::efl::eina::string_view string_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_content_set(::efl::eolian::to_c(string_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool eo_cxx::elm_interface_atspi_editable_text::insert(::efl::eina::string_view string_, int position_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_insert(::efl::eolian::to_c(string_), position_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool eo_cxx::elm_interface_atspi_editable_text::copy(int start_, int end_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_copy(start_, end_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool eo_cxx::elm_interface_atspi_editable_text::cut(int start_, int end_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_cut(start_, end_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool eo_cxx::elm_interface_atspi_editable_text::delete_(int start_, int end_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_delete(start_, end_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool eo_cxx::elm_interface_atspi_editable_text::paste(int position_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_paste(position_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
inline bool eo_cxx::elm_interface_atspi_editable_text::content_set(::efl::eina::string_view string_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_content_set(::efl::eolian::to_c(string_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

inline ::eo_cxx::elm_interface_atspi_editable_text::operator ::elm_interface_atspi_editable_text() const
{
   return *static_cast<::elm_interface_atspi_editable_text const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_interface_atspi_editable_text::operator ::elm_interface_atspi_editable_text&()
{
   return *static_cast<::elm_interface_atspi_editable_text*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_interface_atspi_editable_text::operator ::elm_interface_atspi_editable_text const&() const
{
   return *static_cast<::elm_interface_atspi_editable_text const*>(static_cast<void const*>(this));
}

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
template <typename T>
bool _elm_interface_atspi_editable_text_insert_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * string_, int position_)
{
   try
      {
         return static_cast<T*>(self->this_)->insert(::efl::eolian::to_cxx<::efl::eina::string_view>(string_, std::tuple<std::false_type>()), position_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
template <typename T>
bool _elm_interface_atspi_editable_text_copy_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int start_, int end_)
{
   try
      {
         return static_cast<T*>(self->this_)->copy(start_, end_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
template <typename T>
bool _elm_interface_atspi_editable_text_cut_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int start_, int end_)
{
   try
      {
         return static_cast<T*>(self->this_)->cut(start_, end_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
template <typename T>
bool _elm_interface_atspi_editable_text_delete__wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int start_, int end_)
{
   try
      {
         return static_cast<T*>(self->this_)->delete_(start_, end_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
template <typename T>
bool _elm_interface_atspi_editable_text_paste_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int position_)
{
   try
      {
         return static_cast<T*>(self->this_)->paste(position_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
template <typename T>
bool _elm_interface_atspi_editable_text_content_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * string_)
{
   try
      {
         return static_cast<T*>(self->this_)->content_set(::efl::eolian::to_cxx<::efl::eina::string_view>(string_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_editable_text >
{
   template <typename T>
   struct type
   {
#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
      virtual bool insert(::efl::eina::string_view string_, int position_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_insert(::efl::eolian::to_c(string_), position_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
      virtual bool copy(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_copy(start_, end_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
      virtual bool cut(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_cut(start_, end_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
      virtual bool delete_(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_delete(start_, end_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
      virtual bool paste(int position_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_paste(position_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
      virtual bool content_set(::efl::eina::string_view string_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_content_set(::efl::eolian::to_c(string_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_editable_text >
{
   static constexpr int value = 
#if defined(ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED) && defined(ELM_INTERFACE_ATSPI_EDITABLE_TEXT_BETA)
      6
#elif defined(ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED)
      6
#elif defined(ELM_INTERFACE_ATSPI_EDITABLE_TEXT_BETA)
      0
#else
      0
#endif
;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_interface_atspi_editable_text>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_insert_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_insert);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_copy_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_copy);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_cut_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_cut);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_delete__wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_delete);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_paste_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_paste);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_EDITABLE_TEXT_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_content_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_content_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_editable_text>)
{
   return (ELM_INTERFACE_ATSPI_EDITABLE_TEXT_INTERFACE);
}

} } }

/// @endcond

